#!/usr/bin/gnuplot

set term x11

band = 7
shift = 0.1

set xl "JD - 2400000"
set yl "magnitude [mag]"

set yr [:] reverse
set ytics shift
set grid ytics

load "T0.plt"
set arrow from T0-2400000,graph 0 to T0-2400000,graph 1 nohead lt 0

p "lightcurve.dat" u ($1-2400000):($2+($3-band)*shift)   t "synthetic lightcurve" w lp pt 1 lt 7,\
  "Lc.dat"         u ($1-2400000):2:3                    t "observed lightcurve"  w err lt 3 pt 1 ps 0.5,\
  "Lc.dat"         u ($1-2400000):2:3                    not                      w l lt 3,\
  "chi2_LC.dat"    u ($1-2400000):($2+($4-band)*shift):3 t "residua"              w l lt 1 lw 3
pa -1

set term png small
set out "chi2_LC.png"
rep

q


